import 'package:flutter/material.dart';

import 'tile.dart';
import '../provider/data.dart';

class MovingTile extends Tile {
  int currentCol;
  int currentRow;

  MovingTile(image, size, originalCol, originalRow, this.currentCol, this.currentRow)
      : super(image, size, originalCol, originalRow);

  Container _tileWidget() {
    return Container(
      decoration: BoxDecoration(
        color: Colors.black,
        border: Border.all(
          color: Colors.black,
          width: 1,
        ),
      ),
      child: Image(
          image: this.image.image, width: this.size, height: this.size, fit: BoxFit.fill),
    );
  }

  Container widget(Data myProvider) {
    return Container(
        child: DragTarget<List<int>>(
      builder: (
        BuildContext context,
        List<dynamic> accepted,
        List<dynamic> rejected,
      ) {
        return Container(
          height: this.size,
          width: this.size,
          color: Colors.cyan,
          child: Draggable<List<int>>(
            data: [
              this.currentCol,
              this.currentRow,
            ],

            // Widget when draggable is stationary
            child: this._tileWidget(),

            // Widget when draggable is being dragged
            feedback: this._tileWidget(),

            // Widget to display on original place when being dragged
            childWhenDragging: Container(
              height: this.size,
              width: this.size,
              color: Colors.pinkAccent,
            ),
          ),
        );
      },
      onAccept: (List<int> data) {
        myProvider.swapTiles([this.currentCol, this.currentRow], data);
      },
    ));
  }

  bool isCorrect() {
    return ((this.currentRow == this.originalRow) &&
        (this.currentCol == this.originalCol));
  }
}
